//+------------------------------------------------------------------+
//|                                                 INVICTUS_MTF.mq4 |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property copyright "Copyright 2011, ShamsSoft"
#property link      "http://www.6thorigin.com"

#property indicator_separate_window
#property indicator_minimum 0
#property indicator_maximum 2
#property indicator_buffers 3
#property indicator_color1 Lime
#property indicator_color2 Red
#property indicator_color3 White
#property indicator_width1 3
#property indicator_width2 3
#property indicator_width3 3


double LineUp[];
double LineDown[];
double UnLine[];
				
int	TradePeriod[3];
string iName;			
int counted_bars = 0;

int init()
{   
   SetIndexStyle(0, DRAW_HISTOGRAM, STYLE_SOLID);
   SetIndexBuffer(0, LineUp);   
   SetIndexLabel(0, NULL);
   SetIndexStyle(1, DRAW_HISTOGRAM, STYLE_SOLID);
   SetIndexBuffer(1, LineDown);   
   SetIndexLabel(1, NULL);
   SetIndexStyle(2, DRAW_HISTOGRAM, STYLE_SOLID);
   SetIndexBuffer(2, UnLine);   
   SetIndexLabel(2, NULL);
         
   SetIndexDrawBegin(0, 10);
   SetIndexDrawBegin(1, 10);
   SetIndexDrawBegin(2, 10);
   setPeriods();
   IndicatorShortName("INVICTUS" + iName);
   
   return (0);
}

int deinit()
{
   return (0);
}

int start()
{      
   if (Bars == 10) return (0);
      
   counted_bars = IndicatorCounted();
   if (counted_bars < 0) return (-1);
   if (counted_bars > 0) counted_bars--;
   
   for (int i = Bars - counted_bars - 1; i >= 0; i--)
   {         
      int up = 0, dn = 0, count = ArraySize(TradePeriod);
      for(int k = 0; k < count; k++)
      {
        if(haOpenClose(TradePeriod[k], i) == "up")
        up++;
        if(haOpenClose(TradePeriod[k], i) == "dn")
        dn++;
      }
      if(up == count)
      {
        LineUp[i] = 1;
        LineDown[i] = 0;
        UnLine[i] = 0;
      }
      else if(dn == count)
      {
        LineUp[i] = 0;
        LineDown[i] = 1;
        UnLine[i] = 0;
      }
      else
      {
        LineUp[i] = 0;
        LineDown[i] = 0;
        UnLine[i] = 1;
      }                     
   }
   return (0);
}

string haOpenClose(int prd, int i)
{
  int shift = iBarShift(NULL, prd, Time[i]);
  double haOpen, haClose;
  haOpen =  iCustom(NULL, prd, "Heiken Ashi", 2, shift);
  haClose = iCustom(NULL, prd, "Heiken Ashi", 3, shift);
    
  if(haOpen >= haClose)
  return("dn");
  else
  return("up");  
}


//+------------------------------------------------------------------+
// Set MTF Periods                                           |
//+------------------------------------------------------------------+
void setPeriods()
{
  switch(Period()) 
   {
      case 1: 
         TradePeriod[0]=1; TradePeriod[1]=5; TradePeriod[2]=15;
         iName = "(M1, M5, M15)";
         break;
      case 5: 
         TradePeriod[0]=5; TradePeriod[1]=15; TradePeriod[2]=60;
         iName = "(M5, M15, H1)";
         break;
      case 15: 
         TradePeriod[0]=15; TradePeriod[1]=60; TradePeriod[2]=240;
         iName = "(M15, H1, H4)";
         break;
      case 30: 
         TradePeriod[0]=30; TradePeriod[1]=240; TradePeriod[2]=1440;
         iName = "(M30, H4, D1)";
         break;
      case 60: 
         TradePeriod[0]=60; TradePeriod[1]=240; TradePeriod[2]=1440;
         iName = "(H1, H4, D1)";
         break;
      case 240: 
         TradePeriod[0]=240; TradePeriod[1]=1440; TradePeriod[2]=PERIOD_W1;
         iName = "(H4, D1, W1)";
         break;
      case 1440: 
         TradePeriod[0]=1440; TradePeriod[1]=PERIOD_W1; TradePeriod[2]=PERIOD_MN1;
         iName = "(D1, W1, MN1)";
         break;
      case PERIOD_W1:
         ArrayResize(TradePeriod, 2); 
         TradePeriod[0]=PERIOD_W1; TradePeriod[1]=PERIOD_MN1;
         iName = "(W1, MN1)";
         break;
      case PERIOD_W1:
         ArrayResize(TradePeriod, 1); 
         TradePeriod[0]=PERIOD_MN1;
         iName = "(MN1)";
         break;               
   }
}          