//+------------------------------------------------------------------+
//|                                               InvictusSignal.mq4 |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property copyright "Kashif Javed"
#property link      "the_dascriptor@yahoo.com"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Magenta
#property indicator_color2 Aqua
#property indicator_width1 1
#property indicator_width2 1

extern int CountBars = 1000;
extern bool useTradeTime = false;
extern int FromHourTrade = 0;
extern int ToHourTrade = 23;

//---- buffers
double val1[];
double val2[];
double point;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicator line
   IndicatorBuffers(2);
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexArrow(0,234);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(1,233);
   SetIndexBuffer(0,val1);
   SetIndexBuffer(1,val2);
   point=Point;
   if( Digits==3 || Digits==5 )
   point = point * 10;
   
   if(FromHourTrade < 0 || FromHourTrade > 23)
   FromHourTrade = 0;
   
   if(ToHourTrade < 0 || ToHourTrade > 23)
   ToHourTrade = 23;

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator start function                                  |
//+------------------------------------------------------------------+
int start()
{
   
//----
   if(Bars < CountBars) return(0);
   int atr1, atr2;
   

   int  shift = CountBars - 26;
   while(shift >= 0)
   {
      double range = 0.0;
      for(int j = shift + 1; j <= shift + 10; j++)
      range = range + MathAbs(High[j] - Low[j]);
      range = range/10;
      
      bool tradeon = false;
      if(useTradeTime == false)
      {
        tradeon = true;
      }
      else
      {
        if(ToHourTrade > FromHourTrade &&  TimeHour(Time[shift + 1]) >= FromHourTrade && TimeHour(Time[shift + 1]) <= ToHourTrade)
        tradeon = true;
        if(ToHourTrade < FromHourTrade && ((TimeHour(Time[shift + 1]) >= FromHourTrade && TimeHour(Time[shift + 1]) <= 23) || (TimeHour(Time[shift + 1]) >= 0 && TimeHour(Time[shift + 1]) <= ToHourTrade)))
        tradeon = true;
      }
      
      double u0 =  iCustom(NULL, 0, "INVICTUS_MTF", 0, shift + 1);
      double u1 =  iCustom(NULL, 0, "INVICTUS_MTF", 0, shift + 2);
      double d0 =  iCustom(NULL, 0, "INVICTUS_MTF", 1, shift + 1);
      double d1 =  iCustom(NULL, 0, "INVICTUS_MTF", 1, shift + 2);      
      
      atr1=MathRound(iATR(NULL, 0, 5, shift + 1)/point);
      atr2=MathRound(iATR(NULL, 0, 25, shift + 1)/point);
      
      if(u0 == 1 && u1 == 0 && atr1 > atr2 && ADR(shift + 1, "L") == "ok" && tradeon)
      val2[shift + 1] = Low[shift + 1] - (range * 0.5);
      
      if(d0 == 1 && d1 == 0 && atr1 > atr2 && ADR(shift + 1, "S") == "ok" && tradeon)
      val1[shift + 1] = High[shift + 1] + (range * 0.5);
      
      shift--;
   }

   return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator ADR function                                    |
//+------------------------------------------------------------------+
string ADR(int i, string side)
{
  //ADR
       
     static int adr1, adr5, adr10, adr20, adr;
     double s = 0.0;
     int shift2 = iBarShift(NULL, PERIOD_D1, Time[i]) + 1;    
     for(int rng = 1; rng <= 20; rng++)
     {
        if(TimeDayOfWeek(iTime(NULL, PERIOD_D1, shift2)) == 0) // if day is sunday
        shift2++;

        s=s + (iHigh(NULL, PERIOD_D1, shift2) - iLow(NULL, PERIOD_D1, shift2))/point;
        if(rng == 1) 
        adr1 = MathRound(s);
        if(rng == 5) 
        adr5 = MathRound(s/5);
        if(rng == 10) 
        adr10 = MathRound(s/10);
        if(rng == 20) 
        adr20 = MathRound(s/20);
        shift2++;  
     }
     
     adr = MathRound((adr1 + adr5 + adr10 + adr20)/4.0);
     
   
     int t, RmUp, RmDn, RmLmt;

      int StartOfDay = iBarShift(NULL, 0, iTime(NULL, PERIOD_D1, iBarShift(NULL, PERIOD_D1, Time[i], false)), false);
      double low0 = iLow(NULL, 0, iLowest(NULL, 0, MODE_LOW, StartOfDay, i));
      double high0 = iHigh(NULL, 0, iHighest(NULL, 0, MODE_HIGH, StartOfDay, i));
      t = MathRound((high0 - low0)/point);  

      RmUp =  MathRound(adr - (Close[i] - low0)/point);
      RmDn =  MathRound(adr - (high0 - Close[i])/point);
      RmLmt = MathRound(adr * 0.2);
      
      
      if (RmUp > RmLmt && side == "L")
      return("ok");             
      
      if (RmDn > RmLmt && side == "S")
      return("ok");
      
      return("n");
      
}
//+------------------------------------------------------------------+


