//+------------------------------------------------------------------+
//|                                                       Pivots.mq4 |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+

#property copyright "Kashif Javed"
#property link      "the_dascriptor@yahoo.com"

#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1  Yellow
#property indicator_width1  3
#property indicator_color2  YellowGreen
#property indicator_width2  1
#property indicator_style2  1
#property indicator_color3  Sienna
#property indicator_width3  1
#property indicator_style3  4
#property indicator_color4  Sienna
#property indicator_width4  1
#property indicator_style4  4
#property indicator_color5  Sienna
#property indicator_width5  1
#property indicator_style5  4
#property indicator_color6  Sienna
#property indicator_width6  1
#property indicator_style6  4
#property indicator_color7  Sienna
#property indicator_width7  1
#property indicator_style7  4
#property indicator_color8  Sienna
#property indicator_width8  1
#property indicator_style8  4

//---- input parameters
extern bool showDailyOpen = true;

double Pivot[];
double dailyOpen[], PBuffer[], R1Buffer[], R2Buffer[], R3Buffer[], S1Buffer[], S2Buffer[], S3Buffer[];
double OP, P, R1, R2, R3, S1, S2, S3, LastLow, LastHigh, LastClose;
double x;
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{   
//----
  return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
//---- indicator buffers
   IndicatorShortName("Pivot Levels");
   
   SetIndexStyle(0, DRAW_LINE);
   SetIndexBuffer(0, dailyOpen);      
   SetIndexLabel(0, "Daily Open Line");
   SetIndexStyle(1, DRAW_LINE);
   SetIndexBuffer(1, PBuffer);      
   SetIndexLabel(1, "Daily Pivot Line");
   SetIndexStyle(2, DRAW_LINE);
   SetIndexBuffer(2, R1Buffer);      
   SetIndexLabel(2, "Daily R1 Line");
   SetIndexStyle(3, DRAW_LINE);
   SetIndexBuffer(3, R2Buffer);      
   SetIndexLabel(3, "Daily R2 Line");
   SetIndexStyle(4, DRAW_LINE);
   SetIndexBuffer(4, R3Buffer);      
   SetIndexLabel(4, "Daily R3 Line");
   SetIndexStyle(5, DRAW_LINE);
   SetIndexBuffer(5, S1Buffer);      
   SetIndexLabel(5, "Daily S1 Line");
   SetIndexStyle(6, DRAW_LINE);
   SetIndexBuffer(6, S2Buffer);      
   SetIndexLabel(6, "Daily S2 Line");
   SetIndexStyle(7, DRAW_LINE);
   SetIndexBuffer(7, S3Buffer);      
   SetIndexLabel(7, "Daily S3 Line");
   

   SetIndexDrawBegin(0, 1);

   return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   if(Period() > 240) return(-1);
   
   //---- indicator calculation
   int counted_bars = IndicatorCounted();
   if(counted_bars < 0) return(-1);
   int limit, i;
                  
   //---- last counted bar will be recounted   
   limit = (Bars - counted_bars) - 1;

   for(i = limit; i >= 0; i--)
   {         
     if(TimeDay(Time[i]) != TimeDay(Time[i+1]))
     { 
       OP = Open[i];
       int iDay = iBarShift(NULL, PERIOD_D1, Time[i + 1]);
       LastLow  = iLow(NULL, PERIOD_D1, iDay);
       LastHigh = iHigh(NULL, PERIOD_D1, iDay);
       LastClose = iClose(NULL, PERIOD_D1, iDay);
       P = (LastHigh + LastLow + LastClose)/3;
       R1 = (P * 2) - LastLow;
       S1 = (P * 2) - LastHigh;
       R2 = P + LastHigh - LastLow;
       S2 = P - (LastHigh - LastLow);
       R3 = (P * 2) + LastHigh - (LastLow * 2);
       S3 = (P * 2) - ((LastHigh * 2) - LastLow);       
     }      
      PBuffer[i]  = P;
      S1Buffer[i] = S1;
      R1Buffer[i] = R1;
      S2Buffer[i] = S2;
      R2Buffer[i] = R2;
      S3Buffer[i] = S3;
      R3Buffer[i] = R3;
      if(showDailyOpen)            
      dailyOpen[i] = OP;
   }
   return(0);
  }
//+------------------------------------------------------------------+