//+------------------------------------------------------------------+
//|                                                         xADR.mq4 |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property copyright "Kashif Javed"
#property link      "the_dascriptor@yahoo.com"

#property indicator_chart_window

extern int ATRPeriodLow = 5;
extern int ATRPeriodHigh = 25;
extern int DisplayCorner = 2;
extern double RoomLimitRatio=0.2;
extern bool ExcludeSundayData = true;
extern color TradeableColor = Lime;
extern color UnTradeableColor = Red;
extern color OtherColor = Yellow;

double point;
int FontSize = 8, LastBars = 0;
int periods, x1 = 0, x2 = 0, x3 = 0, x4 = 0, x5 = 0, y = 0;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   point=Point;
   if( Digits==3 || Digits==5 )
   point = point * 10;
   
   if(DisplayCorner < 0 || DisplayCorner > 3)
   DisplayCorner = 2;
   
   if(DisplayCorner == 0)
   {x1 = 200; x2 = 530; x3 = 310; x4 = 370; x5 = 430; y = 3;}
   
   if(DisplayCorner == 3 || DisplayCorner == 1)
   {x1 = 450; x2 = 10; x3 = 330; x4 = 390; x5 = 240; y = 3;}
   
   if(DisplayCorner == 2)
   {x1 = 10; x2 = 340; x3 = 120; x4 = 180; x5 = 240; y = 3;}
   
   ObjectCreate("xADR1", OBJ_LABEL, 0, 0, 1);
   ObjectSet("xADR1", OBJPROP_CORNER, DisplayCorner);
   ObjectSet("xADR1", OBJPROP_XDISTANCE, x1);
   ObjectSet("xADR1", OBJPROP_YDISTANCE, y);
   
   ObjectCreate("xADR2", OBJ_LABEL, 0, 0, 1);
   ObjectSet("xADR2", OBJPROP_CORNER, DisplayCorner);
   ObjectSet("xADR2", OBJPROP_XDISTANCE, x2);
   ObjectSet("xADR2", OBJPROP_YDISTANCE, y);
   
   ObjectCreate("xADR3", OBJ_LABEL, 0, 0, 1);
   ObjectSet("xADR3", OBJPROP_CORNER, DisplayCorner);
   ObjectSet("xADR3", OBJPROP_XDISTANCE, x3);
   ObjectSet("xADR3", OBJPROP_YDISTANCE, y);
   
   ObjectCreate("xADR4", OBJ_LABEL, 0, 0, 1);
   ObjectSet("xADR4", OBJPROP_CORNER, DisplayCorner);
   ObjectSet("xADR4", OBJPROP_XDISTANCE, x4);
   ObjectSet("xADR4", OBJPROP_YDISTANCE, y);
   
   ObjectCreate("xADR5", OBJ_LABEL, 0, 0, 1);
   ObjectSet("xADR5", OBJPROP_CORNER, DisplayCorner);
   ObjectSet("xADR5", OBJPROP_XDISTANCE, x5);
   ObjectSet("xADR5", OBJPROP_YDISTANCE, y);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
  ObjectDelete("xADR1");
  ObjectDelete("xADR2");
  ObjectDelete("xADR3");
  ObjectDelete("xADR4");
  ObjectDelete("xADR5");            
  return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   if(Bars < ATRPeriodHigh + 1) return(0);
   
   //ATR 
   int atr1, atr2;
   color Color;
   string text;
   if(Bars > LastBars)
   {
     atr1=MathRound(iATR(NULL, 0, ATRPeriodLow, 0)/point);
     atr2=MathRound(iATR(NULL, 0, ATRPeriodHigh, 0)/point);
     text="ATR" + ATRPeriodLow + "=" + atr1 + "  ATR" + ATRPeriodHigh + "=" + atr2;
     
     if(atr1 > atr2) 
     Color = TradeableColor; 
     else 
     Color = UnTradeableColor; 
                  
     ObjectSetText("xADR1", text, FontSize, "Arial Narrow", Color);
     
     //ADR
     int n=1;  
     static int adr1, adr5, adr10, adr20, adr;
     double s = 0.0;    
     for(int rng = 1; rng <= 20; rng++)
     {
        while(ExcludeSundayData && TimeDayOfWeek(iTime(NULL, PERIOD_D1, n)) == 0) 
        n++;

        s = s + (iHigh(NULL, PERIOD_D1, n) - iLow(NULL, PERIOD_D1, n))/point;
        if(rng == 1) 
        adr1 = MathRound(s);
        if(rng == 5) 
        adr5 = MathRound(s/5);
        if(rng == 10) 
        adr10 = MathRound(s/10);
        if(rng == 20) 
        adr20 = MathRound(s/20);
        n++;  
     }
     
     adr = MathRound((adr1 + adr5 + adr10 + adr20)/4.0);
     text = "ADR="+adr+"  1d="+adr1+"  5d="+adr5+"  10d="+adr10+"  20d="+adr20;
     ObjectSetText("xADR2",text, FontSize, "Arial Narrow", OtherColor);
   
     int t, RmUp, RmDn, RmLmt;

      int StartOfDay = iBarShift(NULL, 0, iTime(NULL, PERIOD_D1, iBarShift(NULL, PERIOD_D1, Time[0], false)), false);
      double low0 = iLow(NULL, 0, iLowest(NULL, 0, MODE_LOW, StartOfDay, 0));
      double high0 = iHigh(NULL, 0, iHighest(NULL, 0, MODE_HIGH, StartOfDay, 0));
      t = MathRound((high0 - low0)/point);  

      RmUp =  MathRound(adr - (Close[0] - low0)/point);
      RmDn =  MathRound(adr - (high0 - Close[0])/point);
      RmLmt = MathRound(adr * RoomLimitRatio);
      
      text="RmUp:"+RmUp;
      if (RmUp > RmLmt) 
      Color = TradeableColor;
      else 
      Color = UnTradeableColor;
      ObjectSetText("xADR3", text, FontSize, "Arial Narrow", Color);
      
      text="RmDn:"+RmDn;
      if (RmDn > RmLmt)
      Color = TradeableColor;
      else
      Color = UnTradeableColor;
      ObjectSetText("xADR4",text, FontSize, "Arial Narrow", Color);
      
      text="Todays Range="+t;
      ObjectSetText("xADR5",text, FontSize, "Arial Narrow", OtherColor);
      LastBars = Bars;
   } // If Bars
   return(0);
}
//+------------------------------------------------------------------+